// Generated by CoffeeScript 1.6.3
(function() {
  var cycle, exports, fs, getFiles, locateRoot;

  fs = require("fs");

  exports = module.exports = {};

  locateRoot = function(root) {
    if (fs.existsSync(root + "/css/jeet.styl")) {
      return root;
    }
    if (fs.existsSync(root + "/jeet.styl")) {
      root = root.split("/");
      return root.slice(0, root.length - 1).join("/");
    } else {
      return false;
    }
  };

  getFiles = function(dir, done) {
    var results;
    results = {};
    return fs.readdir(dir, function(err, list) {
      var i, next;
      if (err) {
        return done(err);
      }
      i = 0;
      return (next = function() {
        var file;
        file = list[i++];
        if (!file) {
          return done(null, results);
        }
        if (file.charAt(0) === ".") {
          return next();
        } else {
          file = dir + '/' + file;
          return fs.stat(file, function(err, stat) {
            if (stat && stat.isDirectory()) {
              return getFiles(file, function(err, res) {
                var f, v;
                for (f in res) {
                  v = res[f];
                  results[f] = v;
                }
                return next();
              });
            } else {
              results[file] = stat;
              return next();
            }
          });
        }
      })();
    });
  };

  cycle = function(path, list, cb) {
    return getFiles(path, function(err, files) {
      var f, s;
      for (f in files) {
        s = files[f];
        if (!list.hasOwnProperty(f)) {
          cb(f);
        } else if (list[f].size !== s.size || list[f].mtime.getTime() !== s.mtime.getTime()) {
          cb(f);
        }
      }
      return setTimeout(function() {
        return cycle(path, files, cb);
      }, 100);
    });
  };

  exports.watch = function(cb) {
    var root;
    root = locateRoot(process.cwd());
    if (root) {
      exports.stylFile = root + "/css/";
      exports.jsDir = root + "/js";
      cb(root + "/css/custom.styl");
      cb(root + "/js/main.js");
      return getFiles(root, function(err, files) {
        return cycle(root, files, cb);
      });
    } else {
      console.log("\x1B[0;31mDoesn't appear to be a Jeet Directory\x1B[0;0m");
      return process.kill();
    }
  };

}).call(this);
